import { defineConfig } from 'vite';
import pkg from '../package.json';
import { nodePolyfills } from 'vite-plugin-node-polyfills'

const publicDependencies = Object.keys(pkg.dependencies).filter(
	(dependency) => !dependency.startsWith('@dyte-in/')
				&& !dependency.startsWith('@dyteinternals/')
				&& dependency !== 'lodash-es'
				&& dependency !== 'axios'
);

export default defineConfig({
	build: {
		emptyOutDir: false,
		lib: {
			entry: ['src/mock/DyteClientMock.ts'],
			formats: ['cjs', 'es'],
			fileName: (format, entryName) => `${entryName}.${format}.js`,
		},
		target: 'es2015',
		rollupOptions: {
			external: publicDependencies,
		},
	},
	envPrefix: 'DYTE_',
	server: {
		port: 3000,
	},
	plugins: [
		nodePolyfills({
		  // To add only specific polyfills, add them here. If no option is passed, adds all polyfills
		  include: ['events', 'buffer'],
		})
	],
});
