<!-- PROJECT LOGO -->
<p align="center">
  <a href="https://dyte.in">
    <img src="https://dyte-uploads.s3.ap-south-1.amazonaws.com/dyte-logo-dark.svg" alt="Logo" width="80">
  </a>
  <h3 align="center">Dyte Web Core</h3>

  <p align="center">
    A SDK that provides Dyte's core functionality.
    <br />
    <a href="https://docs.dyte.io"><strong>Explore the docs »</strong></a>
    <br />
    <br />
    <a href="https://demo.dyte.io">View Demo</a>
    ·
    <a href="https://docs.dyte.io/discuss">Report Bug</a>
    ·
    <a href="https://docs.dyte.io/discuss">Request Feature</a>
  </p>
</p>



<!-- TABLE OF CONTENTS -->

## Table of Contents

* [About the Project](#about-the-project)
  * [Built With](#built-with)
* [Installation](#installation)
* [Usage](#usage)
* [About](#about)



<!-- ABOUT THE PROJECT -->
## About The Project

The core SDK provides Dyte's core functionality, while letting a developer build a custom UI over it.

### Built With

* [Dyte](https://dyte.io)
* [Typescript](https://typescriptlang.org)


<!-- INSTALLATION -->
## Installation

```sh
npm install @dytesdk/web-core
```



<!-- USAGE EXAMPLES -->
## Usage

A `meeting` object can be created using the `DyteClient.init()` method.

```ts
const meeting = await DyteClient.init({
    authToken: "<AuthTokenHere>",
    defaults: {
        audio: false,
        video: false,
    }
});
```

The `meeting` object is used for all interaction with Dyte's servers. For example, the following code snippet is used for a user to join a room.

```ts
await meeting.join();
```

_For more examples, please refer to the [Documentation](https://docs.dyte.in)._

## About

`@dytesdk/web-core` is created & maintained by Dyte, Inc. You can find us on Twitter - [@dyte_io](https://twitter.com/dyte_io) or write to us at `dev@dyte.io`.

The names and logos for Dyte are trademarks of Dyte, Inc.

We love open source software! See [our other projects](https://github.com/dyte-in) and [our products](https://dyte.io).
